Index: pjproject/trunk/tests/automated/configure.py
===================================================================
--- pjproject/trunk/tests/automated/configure.py	(revision 3125)
+++ pjproject/trunk/tests/automated/configure.py	(revision 3131)
@@ -67,7 +67,11 @@
 			self.release = "2008"
 			break
-		    else:
+		    elif major=="16":
 			self.version = "10"
 			self.release = "2010"
+			break
+		    else:
+			self.version = "11"
+			self.release = "2012"
 			break
 	    proc.wait()
Index: pjproject/trunk/tests/automated/gnu.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu.xml.template	(revision 3125)
+++ pjproject/trunk/tests/automated/gnu.xml.template	(revision 3131)
@@ -4,10 +4,10 @@
 	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-default" disabled="$(DISABLED)" >
 		<Update />
-		<Write file="user.mak">
+		<FileWrite file="user.mak">
 		  <![CDATA[
 # Written by ccdash
 ]]>			
-		</Write>
-		<Write file="pjlib/include/pj/config_site.h">
+		</FileWrite>
+		<FileWrite file="pjlib/include/pj/config_site.h">
 		  <![CDATA[
 /* Written by ccdash */
@@ -15,5 +15,5 @@
 #define PJMEDIA_HAS_G7221_CODEC 1
 ]]>			
-		</Write>
+		</FileWrite>
 		<Configure cmd="./aconfigure" />
 		<Build cmd="make dep &amp;&amp; make distclean &amp;&amp; make" />
Index: pjproject/trunk/tests/automated/msvc.xml.template
===================================================================
--- pjproject/trunk/tests/automated/msvc.xml.template	(revision 3125)
+++ pjproject/trunk/tests/automated/msvc.xml.template	(revision 3131)
@@ -4,5 +4,5 @@
 	<Submit group="Experimental" build="$(OS)-$(VS)-$(VSTARGET)-default" >
 		<Update />
-		<Write file="pjlib/include/pj/config_site.h">
+		<FileWrite file="pjlib/include/pj/config_site.h">
 		  <![CDATA[
 /* Written by ccdash */
@@ -10,12 +10,12 @@
 #define PJMEDIA_HAS_G7221_CODEC 1
 ]]>			
-		</Write>
+		</FileWrite>
 		<Configure cmd="cmd /c echo success" />
 		<Build cmd='vcbuild.exe /nologo /nohtmllog /nocolor /rebuild pjproject-vs8.sln "$(VSTARGET)|Win32"' />
-		<Test name="pjlib-test" info="" wdir="pjlib/bin" cmd="pjlib-test-i386-Win32-vs8-$(VSTARGET)" />
-		<Test name="pjlib-util-test" info="" wdir="pjlib-util/bin" cmd="pjlib-util-test-i386-Win32-vs8-$(VSTARGET)" />
-		<Test name="pjnath-test" info="" wdir="pjnath/bin" cmd="pjnath-test-i386-Win32-vs8-$(VSTARGET)" />
-		<Test name="pjmedia-test" info="" wdir="pjmedia/bin" cmd="pjmedia-test-i386-Win32-vs8-$(VSTARGET)" />
-		<Test name="pjsip-test" info="" wdir="pjsip/bin" cmd="pjsip-test-i386-Win32-vs8-$(VSTARGET)" />
+		<Test name="pjlib-test" info="" wdir="pjlib/bin" cmd="pjlib-test-i386-Win32-vc8-$(VSTARGET)" />
+		<Test name="pjlib-util-test" info="" wdir="pjlib-util/bin" cmd="pjlib-util-test-i386-Win32-vc8-$(VSTARGET)" />
+		<Test name="pjnath-test" info="" wdir="pjnath/bin" cmd="pjnath-test-i386-Win32-vc8-$(VSTARGET)" />
+		<Test name="pjmedia-test" info="" wdir="pjmedia/bin" cmd="pjmedia-test-i386-Win32-vc8-$(VSTARGET)" />
+		<Test name="pjsip-test" info="" wdir="pjsip/bin" cmd="pjsip-test-i386-Win32-vc8-$(VSTARGET)" />
 		$(PJSUA-TESTS)
 	</Submit>
Index: pjproject/trunk/tests/automated/symbian-aps.xml.template
===================================================================
--- pjproject/trunk/tests/automated/symbian-aps.xml.template	(revision 3131)
+++ pjproject/trunk/tests/automated/symbian-aps.xml.template	(revision 3131)
@@ -0,0 +1,78 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+    <!-- *********************************************************
+     ** This file contains scenario for APS and APS-Direct  **
+     ********************************************************* -->
+
+    <!-- ******************************
+         **            APS           **
+         ****************************** -->
+    <Submit group="Experimental" build="$(OS)-$(S60TARGETNAME)-APS" >
+        <Update />
+        <!-- Configure config_site.h -->
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJMEDIA_AUDIO_DEV_HAS_SYMB_APS	1
+#define PJMEDIA_AUDIO_DEV_HAS_SYMB_MDA	0
+#include <pj/config_site_sample.h>
+]]>
+		</FileWrite>
+		<!-- Configure symbian_ua.mmp -->
+		<FileWrite file="build.symbian/symbian_ua.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+		  <![CDATA[
+#define SND_HAS_APS	1
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	0
+]]>
+		</FileWrite>
+		<!-- Configure symbian_ua_gui.mmp -->
+		<FileWrite file="pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+		  <![CDATA[
+#define SND_HAS_APS	1
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	0
+]]>
+		</FileWrite>
+		<Configure cmd="cmd /c echo success" />
+		<Build wdir="build.symbian" cmd='cmd /C &quot;bldmake bldfiles &amp;&amp; abld reallyclean $(S60TARGET) &amp;&amp; abld build $(S60TARGET)&quot;' />
+	</Submit>
+
+
+    <!-- ******************************
+         **       APS-Direct         **
+         ****************************** -->
+    <Submit group="Experimental" build="$(OS)-$(S60TARGETNAME)-APS-Direct" >
+        <Update />
+        <!-- Configure config_site.h -->
+        <FileWrite file="pjlib/include/pj/config_site.h">
+            <![CDATA[
+/* Written by ccdash */
+#define PJ_CONFIG_NOKIA_APS_DIRECT
+#include <pj/config_site_sample.h>
+]]>
+        </FileWrite>
+        <Configure cmd="cmd /c echo success" />
+        <Build wdir="build.symbian" cmd='cmd /C &quot;bldmake bldfiles &amp;&amp; abld reallyclean $(S60TARGET) &amp;&amp; abld build $(S60TARGET)&quot;' />
+        
+        <!-- Restore symbian_ua.mmp -->
+        <FileWrite file="build.symbian/symbian_ua.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+            <![CDATA[
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	1
+]]>
+        </FileWrite>
+        <!-- Restore symbian_ua_gui.mmp -->
+        <FileWrite file="pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+            <![CDATA[
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	1
+]]>
+        </FileWrite>
+
+    </Submit>
+
+</Scenario>
+
Index: pjproject/trunk/tests/automated/symbian-vas.xml.template
===================================================================
--- pjproject/trunk/tests/automated/symbian-vas.xml.template	(revision 3131)
+++ pjproject/trunk/tests/automated/symbian-vas.xml.template	(revision 3131)
@@ -0,0 +1,79 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+    <!-- *********************************************************
+     ** This file contains scenario for VAS and VAS-Direct  **
+     ********************************************************* -->
+
+    <!-- ******************************
+         **            VAS           **
+         ****************************** -->
+    <Submit group="Experimental" build="$(OS)-$(S60TARGETNAME)-VAS1" >
+        <Update />
+        <!-- Configure config_site.h -->
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJMEDIA_AUDIO_DEV_HAS_SYMB_VAS	1
+#define PJMEDIA_AUDIO_DEV_HAS_SYMB_APS	0
+#define PJMEDIA_AUDIO_DEV_HAS_SYMB_MDA	0
+#include <pj/config_site_sample.h>
+]]>
+		</FileWrite>
+		<!-- Configure symbian_ua.mmp -->
+		<FileWrite file="build.symbian/symbian_ua.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+		  <![CDATA[
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	1
+#define SND_HAS_MDA	0
+]]>
+		</FileWrite>
+		<!-- Configure symbian_ua_gui.mmp -->
+		<FileWrite file="pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+		  <![CDATA[
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	1
+#define SND_HAS_MDA	0
+]]>
+		</FileWrite>
+		<Configure cmd="cmd /c echo success" />
+		<Build wdir="build.symbian" cmd='cmd /C &quot;bldmake bldfiles &amp;&amp; abld reallyclean $(S60TARGET) &amp;&amp; abld build $(S60TARGET)&quot;' />
+	</Submit>
+
+
+    <!-- ******************************
+         **       VAS-Direct         **
+         ****************************** -->
+    <Submit group="Experimental" build="$(OS)-$(S60TARGETNAME)-VAS1-Direct" >
+        <Update />
+        <!-- Configure config_site.h -->
+        <FileWrite file="pjlib/include/pj/config_site.h">
+            <![CDATA[
+/* Written by ccdash */
+#define PJ_CONFIG_NOKIA_VAS_DIRECT
+#include <pj/config_site_sample.h>
+]]>
+        </FileWrite>
+        <Configure cmd="cmd /c echo success" />
+        <Build wdir="build.symbian" cmd='cmd /C &quot;bldmake bldfiles &amp;&amp; abld reallyclean $(S60TARGET) &amp;&amp; abld build $(S60TARGET)&quot;' />
+        
+        <!-- Restore symbian_ua.mmp -->
+        <FileWrite file="build.symbian/symbian_ua.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+            <![CDATA[
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	1
+]]>
+        </FileWrite>
+        <!-- Restore symbian_ua_gui.mmp -->
+        <FileWrite file="pjsip-apps/src/symbian_ua_gui/group/symbian_ua_gui.mmp" replace_begin="// =BEGIN" replace_end="// =END">
+            <![CDATA[
+#define SND_HAS_APS	0
+#define SND_HAS_VAS	0
+#define SND_HAS_MDA	1
+]]>
+        </FileWrite>
+
+    </Submit>
+
+</Scenario>
+
Index: pjproject/trunk/tests/automated/symbian.xml.template
===================================================================
--- pjproject/trunk/tests/automated/symbian.xml.template	(revision 3125)
+++ pjproject/trunk/tests/automated/symbian.xml.template	(revision 3131)
@@ -1,8 +1,8 @@
 <?xml version="1.0" ?>
 <Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
- 
+        <!-- Symbian S60 default -->
 	<Submit group="Experimental" build="$(OS)-$(S60TARGETNAME)-default" >
 		<Update disabled="1" />
-		<Write file="pjlib/include/pj/config_site.h">
+		<FileWrite file="pjlib/include/pj/config_site.h">
 		  <![CDATA[
 /* Written by ccdash */
@@ -13,9 +13,8 @@
 #define PJMEDIA_HAS_G7221_CODEC 1
 ]]>			
-		</Write>
+		</FileWrite>
 		<Configure cmd="cmd /c echo success" />
 		<Build wdir="build.symbian" cmd='cmd /C &quot;bldmake bldfiles &amp;&amp; abld reallyclean $(S60TARGET) &amp;&amp; abld build $(S60TARGET)&quot;' />
 	</Submit>
-	
 </Scenario>
 