Index: pjproject/trunk/tests/automated/configure.py
===================================================================
--- pjproject/trunk/tests/automated/configure.py	(revision 3142)
+++ pjproject/trunk/tests/automated/configure.py	(revision 3143)
@@ -87,5 +87,5 @@
 		# Check that EPOCROOT is set
 		if not "EPOCROOT" in os.environ:
-		    print "Error: EPOCROOT environment variable is not set"
+		    sys.stderr.write("Error: EPOCROOT environment variable is not set\n")
 		    sys.exit(1)
 		epocroot = os.environ["EPOCROOT"]
@@ -108,7 +108,7 @@
 
 		if sdk1 != sdk2:
-		    print "Error: default SDK in device doesn't match EPOCROOT"
-		    print "Default device SDK =", sdk2
-		    print "EPOCROOT SDK =", sdk1
+		    sys.stderr.write("Error: default SDK in device doesn't match EPOCROOT\n")
+		    sys.stderr.write("Default device SDK = " + sdk2 + "\n")
+		    sys.stderr.write("EPOCROOT SDK = " + sdk1 + "\n")
 		    sys.exit(1)
 
@@ -130,5 +130,5 @@
 			os_info = platform.release() + "-" + platform.version() + "-" + platform.win32_ver()[2]
 	elif platform.system().lower() == "linux":
-                os_info =  + "-" + "-".join(platform.linux_distribution()[0:2])
+                os_info =  "-" + "-".join(platform.linux_distribution()[0:2])
 
 	# vs_target
@@ -160,5 +160,5 @@
 		suffix = proc.stdout.readline().rstrip(" \r\n")
 	else:
-		sys.stderr.write("Error: unsupported built type " + build_type + "\n")
+		sys.stderr.write("Error: unsupported build type '" + build_type + "'\n")
 		sys.exit(1)
 
@@ -185,4 +185,19 @@
                 elif text.find("$(DISABLED)") >= 0:
                         text = text.replace("$(DISABLED)", "0")
+                elif text.find("$(IPPROOT)") >= 0:
+                        if not os.environ.has_key("IPPROOT"):
+                                sys.stderr.write("Error: environment variable IPPROOT is needed but not set\n")
+                                sys.exit(1)
+                        text = text.replace("$(IPPROOT)", os.environ["IPPROOT"])
+                elif text.find("$(IPPSAMPLES)") >= 0:
+                        if not os.environ.has_key("IPPSAMPLES"):
+                                sys.stderr.write("Error: environment variable IPPSAMPLES is needed but not set\n")
+                                sys.exit(1)
+                        text = text.replace("$(IPPSAMPLES)", os.environ["IPPSAMPLES"])
+                elif text.find("$(IPPARCH)") >= 0:
+                        if not os.environ.has_key("IPPARCH"):
+                                text = text.replace("$(IPPARCH)", "")
+                        else:
+                                text = text.replace("$(IPPARCH)", os.environ["IPPARCH"])
                 elif text.find("$(OS)") >= 0:
                         text = text.replace("$(OS)", os_info)
@@ -202,9 +217,10 @@
 def main(args):
 	global vs_target, s60_target, build_type
+        output = sys.stdout
         usage = """Usage: configure.py [OPTIONS] scenario_template_file
 
 Where OPTIONS:
-  -t TYPE		Specify build type for Windows since we support both
-			Visual Studio and Mingw. If not specified, it will be
+  -o FILE               Output to file, otherwise to stdout.
+  -t TYPE		Specify build type. If not specified, it will be
 			asked if necessary. Values are: 
 			    vs:    Visual Studio
@@ -226,5 +242,13 @@
         args.pop(0)
 	while len(args):
-		if args[0]=='-vstarget':
+                if args[0]=='-o':
+                        args.pop(0)
+                        if len(args):
+                                output = open(args[0], "wt")
+                                args.pop(0)
+                        else:
+                                sys.stderr.write("Error: needs value for -o\n")
+                                sys.exit(1)
+		elif args[0]=='-vstarget':
 			args.pop(0)
 			if len(args):
@@ -257,8 +281,8 @@
 
         if len(args) != 1:
-                print usage
+                sys.stderr.write(usage + "\n")
                 return 1
         
-	if not build_type and (platform.system().lower() == "windows" or platform.system().lower() == "microsoft"):
+	if not build_type:
 	    print "Enter the build type (values: vs, gnu, s60) [vs]: ",
 	    build_type = sys.stdin.readline().replace("\n", "").replace("\r", "")
@@ -277,5 +301,7 @@
         
         tpl = replace_vars(tpl)
-        print tpl
+        output.write(tpl)
+        if output != sys.stdout:
+                output.close()
         return 0
 
Index: pjproject/trunk/tests/automated/gnu-ipp.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 3143)
+++ pjproject/trunk/tests/automated/gnu-ipp.xml.template	(revision 3143)
@@ -0,0 +1,27 @@
+<?xml version="1.0" ?>
+<Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
+	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-IPP" disabled="$(DISABLED)" >
+		<Update />
+		<FileWrite file="user.mak">
+		  <![CDATA[
+# Written by ccdash
+]]>			
+		</FileWrite>
+		<FileWrite file="pjlib/include/pj/config_site.h">
+		  <![CDATA[
+/* Written by ccdash */
+#define PJ_HAS_IPV6		1
+#define PJMEDIA_HAS_G7221_CODEC 0
+#define PJMEDIA_HAS_INTEL_IPP	1
+]]>			
+		</FileWrite>
+		<Configure cmd='./aconfigure --enable-ipp --with-ipp="$(IPPROOT)" --with-ipp-samples="$(IPPSAMPLES)" --with-ipp-arch=$(IPPARCH)' />
+		<Build cmd="make dep &amp;&amp; make distclean &amp;&amp; make" />
+		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" />
+		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" />
+		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" />
+		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" />
+		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" />
+		$(PJSUA-TESTS)
+	</Submit>
+</Scenario>
Index: pjproject/trunk/tests/automated/gnu.xml.template
===================================================================
--- pjproject/trunk/tests/automated/gnu.xml.template	(revision 3142)
+++ pjproject/trunk/tests/automated/gnu.xml.template	(revision 3143)
@@ -2,5 +2,5 @@
 <Scenario site="$(HOSTNAME)" url="http://my.cdash.org/submit.php?project=PJSIP" wdir="$(PJDIR)">
  
-	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-default" disabled="$(DISABLED)" >
+	<Submit group="Experimental" build="$(SUFFIX)-$(GCC)-IPP" disabled="$(DISABLED)" >
 		<Update />
 		<FileWrite file="user.mak">
@@ -14,13 +14,14 @@
 #define PJ_HAS_IPV6		1
 #define PJMEDIA_HAS_G7221_CODEC 1
+#define PJMEDIA_HAS_INTEL_IPP	1
 ]]>			
 		</FileWrite>
 		<Configure cmd="./aconfigure" />
 		<Build cmd="make dep &amp;&amp; make distclean &amp;&amp; make" />
-		<Test name="pjlib-test" info="" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" />
-		<Test name="pjlib-util-test" info="" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" />
-		<Test name="pjnath-test" info="" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" />
-		<Test name="pjmedia-test" info="" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" />
-		<Test name="pjsip-test" info="" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" />
+		<Test name="pjlib-test" wdir="pjlib/bin" cmd="./pjlib-test-$(SUFFIX)" />
+		<Test name="pjlib-util-test" wdir="pjlib-util/bin" cmd="./pjlib-util-test-$(SUFFIX)" />
+		<Test name="pjnath-test" wdir="pjnath/bin" cmd="./pjnath-test-$(SUFFIX)" />
+		<Test name="pjmedia-test" wdir="pjmedia/bin" cmd="./pjmedia-test-$(SUFFIX)" />
+		<Test name="pjsip-test" wdir="pjsip/bin" cmd="./pjsip-test-$(SUFFIX)" />
 		$(PJSUA-TESTS)
 	</Submit>
Index: pjproject/trunk/tests/automated/run.py
===================================================================
--- pjproject/trunk/tests/automated/run.py	(revision 3142)
+++ pjproject/trunk/tests/automated/run.py	(revision 3143)
@@ -1,2 +1,3 @@
+#!/usr/bin/python
 import sys
 import ccdash